"use strict";
/*
 * Copyright 2020 The Kale Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const TextField_1 = require("@material-ui/core/TextField");
const core_1 = require("@material-ui/core");
const styles_1 = require("@material-ui/core/styles");
const LightTooltip_1 = require("./LightTooltip");
const useStyles = styles_1.makeStyles(() => styles_1.createStyles({
    label: {
        color: 'var(--jp-input-border-color)',
        fontSize: 'var(--jp-ui-font-size2)',
    },
    input: {
        color: 'var(--jp-ui-font-color1)',
    },
    textField: {
        width: '100%',
    },
    menu: {
        backgroundColor: 'var(--jp-layout-color1)',
        color: 'var(--jp-ui-font-color1)',
    },
    helperLabel: {
        color: 'var(--jp-info-color0)',
    },
}));
exports.Select = props => {
    const classes = useStyles({});
    const { index, value, values, helperText = null, variant = 'outlined', updateValue } = props, rest = __rest(props, ["index", "value", "values", "helperText", "variant", "updateValue"]);
    const disableMenuItem = (event, invalidOption) => {
        if (invalidOption) {
            event.stopPropagation();
        }
    };
    const getOptionClassNames = (option) => {
        const classNames = [];
        if (option.tooltip) {
            classNames.push('menu-item-tooltip');
        }
        return classNames.join(' ');
    };
    return (
    // @ts-ignore
    React.createElement(TextField_1.default, Object.assign({ select: true }, rest, { margin: "dense", value: value, variant: variant, className: classes.textField, onChange: evt => updateValue(evt.target.value, index), InputLabelProps: {
            classes: { root: classes.label },
            shrink: value !== '',
        }, InputProps: { classes: { root: classes.input } }, SelectProps: { MenuProps: { PaperProps: { className: classes.menu } } }, FormHelperTextProps: { classes: { root: classes.helperLabel } } }), values.map((option) => (React.createElement(core_1.MenuItem, { key: option.value, value: option.value, disabled: !!option.invalid, className: getOptionClassNames(option) }, option.tooltip ? (React.createElement(LightTooltip_1.LightTooltip, { title: option.tooltip, placement: "top-start", interactive: !(typeof option.tooltip === 'string'), TransitionComponent: core_1.Zoom },
        React.createElement("div", { className: "menu-item-label", onClick: ev => disableMenuItem(ev, !!option.invalid) }, option.label))) : (option.label))))));
};
